# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2013 RFUS TEAM <gau1991@gmail.com>
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 2, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

# This is your preferences dialog.
#
# Define your preferences in
# data/glib-2.0/schemas/net.launchpad.rfus.gschema.xml
# See http://developer.gnome.org/gio/stable/GSettings.html for more info.

from gi.repository import Gio # pylint: disable=E0611

import gettext
from gettext import gettext as _
gettext.textdomain('rfus')

import logging
logger = logging.getLogger('rfus')

from rfus_lib.PreferencesDialog import PreferencesDialog

import os
import ConfigParser
from gi.repository import Gtk # pylint: disable=E0611


#to read varibles in section in config parser
def ConfigSectionMap(section,Config):
    dict1 = {}
    options = Config.options(section)
    for option in options:
        try:
            dict1[option] = Config.get(section, option)
            if dict1[option] == -1:
                DebugPrint("skip: %s" % option)
        except:
            print("exception on %s!" % option)
            dict1[option] = None
    return dict1


#preference dialog window
class PreferencesRfusDialog(PreferencesDialog):
    __gtype_name__ = "PreferencesRfusDialog"

    #on apply button clicked in preference window
    def on_apply_clicked(self, button):
        sz = self.ui.osize.get_value_as_int()
        cl = self.ui.clo.get_text()        
        hm = os.getenv("HOME")
        cfpath = os.path.join(hm,'.config/rfus.conf')
        cffile = open(cfpath,'w')
        Config = ConfigParser.ConfigParser()
        Config.add_section('rfus')
        Config.set('rfus','size',sz)
        Config.set('rfus','clo', cl)
        Config.write(cffile)
        cffile.close()
        self.destroy()

    #initialization of window
    def finish_initializing(self, builder): # pylint: disable=E1002
        """Set up the preferences dialog"""
        super(PreferencesRfusDialog, self).finish_initializing(builder)

        # Bind each preference widget to gsettings
        settings = Gio.Settings("net.launchpad.rfus")

        #Path to store basic configuration file
        hm = os.getenv("HOME")
        cfpath = os.path.join(hm,'.config/rfus.conf')
        if os.path.isfile(cfpath):
            Config = ConfigParser.ConfigParser()
            Config.read(cfpath)
            try:
                size = ConfigSectionMap("rfus", Config)['size']
                size = int(size)
                self.ui.osize.set_value(size)
            except:
                print ""
            try:
                clo = ConfigSectionMap("rfus", Config)['clo']
                self.ui.clo.set_text(clo)
            except:
                print ""
